import numpy as np
#import scipy.optimize
#import matplotlib.pyplot as plt

from lmfit import Minimizer, Parameters, fit_report
#import lmfit
#nacteni dat do matice
data=np.loadtxt('Data.dat') 
xdata=data[:,0]
ydata=data[:,1]

#definice residualu: rozdilu fitovane funkce a dat
def residual(params, x, y):
    eINF=params['eINF']
    w=params['w']
    g=params['g']
    e = eINF-w**2/(x*(x+1j*g))
    N = e**0.5
    return abs((N-1)/(N+1))**2-y     

params = Parameters()
params.add('eINF', value=9,vary=True)
params.add('w', value=1780,vary=True)
params.add('g', value=300,vary=True)

#fitovani
minner = Minimizer(residual, params, fcn_args=(xdata,ydata))
result = minner.minimize()


# calculate final result: data + residual
final = ydata + result.residual

# write error report, alternative result.params.pretty_print()
print(fit_report(result))

#ulozeni nafitovaneho spektra do souboru
FileData= open('Spektrum.dat', 'w')
for i in range(len(xdata)):
    print >>FileData, xdata[i],final[i]

#ulozeni statistiky do souboru
FileFit = open('Statistika.dat', 'w')
print >> FileFit, fit_report(result)

ResultingP= result.params.valuesdict()
print ResultingP

# vykresleni fitu na monitor
import pylab
pylab.plot(xdata, ydata, 'k-')
pylab.plot(xdata, final, 'r-')
pylab.show()

